# -*- coding: utf-8 -*-
#    This program plots the cumulated distribution from popularity data.
#    In order to generate the graph presented in figure 3.5 of "Sharing"
#    it must be run on the hutorrent_allknownfilms.csv
#    dataset using the following command:
#    python figure3-5.py hutorrent_allknownfilms.csv
#
#    Copyright (C) 2011 - Philippe Aigrain
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


from pylab import *
import csv

def power(x,a):
  return(x**(-a))

def main(argv):
  if len(argv) < 2:
    print ("Usage: %s <name of csv file for dist 1>") % argv[0]
    print "Plots cumulated distribution from popularity data"
    sys.exit(0)
  # Let's first compute the number of lines in the data file
  cr = csv.reader(open(argv[1],"rb"))
  N = 0
  for row in cr:
    N += 1
# Initializing stuff
  ind = range(N)
  s1 = zeros(N,float)
  t1 = zeros(N,float)
# Reading data for dist 1
  cr = csv.reader(open(argv[1],"rb"))
  tot1 = 0.0
  i = 0
  for row in cr:
    s1[i] = 1.0*(int) (row[0])
    tot1 += s1[i]
    i += 1
  for i in range(N):
    s1[i] = s1[i] / tot1
# Normalized cumulated
  for i in range(0,N,1):
      if i >0:
        t1[i] = s1[i]+t1[i-1]
      else:
        t1[i] = s1[i]
  plotpar = {'axes.labelsize': 24,
               'text.fontsize': 24,
               'legend.fontsize': 20,
               'xtick.labelsize': 22,
               'ytick.labelsize': 22,
               'text.usetex': False}
  rcParams.update(plotpar)
  close(1)
  r5 = math.floor(N*0.05)
  figure(num=1, figsize=(16,12), facecolor='w', edgecolor='k')
# Plotting
  plot(ind,t1,'k-',antialiased=True)
# Replace by following line for color figure
#  plot(ind,t1,'b-', lw=2, antialiased=True)
  annotate('58.8% of attention devoted\nto 5% most popular works', (r5+40,t1[r5]-0.08), xytext=None, xycoords='data', textcoords='data', arrowprops=None,fontsize=20)
  xaxislabel= "popularity ranks"
  xlabel(xaxislabel)
  axvline(x=r5, ymin=0, ymax=t1[r5], color='k',linestyle='dotted', lw=2)
  axhline(y=t1[r5], xmin=0, xmax=r5, color='k',linestyle='dotted', lw=2)
# Replace by following lines for color images
#  axvline(x=r5, ymin=0, ymax=t1[r5], color='r',linestyle='dotted', lw=2)
#  axhline(y=t1[r5], xmin=0, xmax=r5, color='r',linestyle='dotted', lw=2)
  yaxislabel = "Cumulated popularity share"
  ylabel(yaxislabel)
  ylim(0.0, 1.0)
  grid(True)
  savefig('illustration.png')
  show()
#  pylab.xlabel(r"bla $\alpha$") -> illustrating use of LaTeX in figure text

if __name__ == '__main__':
    main(sys.argv)
